#include "parallelepipede.h"

parallelepipede::parallelepipede (float alpha, float rouge, float vert, float bleu, float larg, float haut, float prof) // Constructeur
{
	largeur = larg / 2;
	hauteur = haut / 2;
	profondeur = prof / 2;

	// Dfinition des couleurs
	couleurF (alpha, rouge, vert, bleu);

	gereCouleur (true);
	bNormalize = false;
}

void parallelepipede::genere (int mode)
{
	if (uiDispLst != GL_INVALID_VALUE && uiDispLst != GL_INVALID_OPERATION && glIsList(uiDispLst))
	{
		glNewList(uiDispLst, GL_COMPILE);

		switch (mode)
		{
			case POL_POINTS:
				Point(); // Sphere par point
				break;

			case POL_LIGNES:
				Ligne ();
				break;

			case POL_PLEIN:
				Plein();
				break;
		}

		glEndList();
	}
}

void parallelepipede::Point (void)
{
	glBindTexture( GL_TEXTURE_2D, 0);
	glBegin(GL_POINTS);

		glNormal3i(1, 1, 1);
		glVertex3f(largeur, hauteur, profondeur);

		glNormal3i(1, 1, -1);
		glVertex3f(largeur, hauteur, -profondeur);

		glNormal3i(1, -1, 1);
		glVertex3f(largeur, -hauteur, profondeur);

		glNormal3i(1, -1, -1);
		glVertex3f(largeur, -hauteur, -profondeur);

		glNormal3i(-1, 1, 1);
		glVertex3f(-largeur, hauteur, profondeur);

		glNormal3i(-1, -1, 1);
		glVertex3f(-largeur, -hauteur, profondeur);

		glNormal3i(-1, -1, -1);
		glVertex3f(-largeur, -hauteur, -profondeur);

		glNormal3i(-1, 1, -1);
		glVertex3f(-largeur, hauteur, -profondeur);

	glEnd();
}

void parallelepipede::Ligne (void)
{
	// Mailles en serpent d'un sommet  l'autre de la sphre
	glBindTexture( GL_TEXTURE_2D, 0);
	glBegin(GL_LINES);

	// Face avant

		glNormal3f(0.0f,1.0f,1.0f);
		glVertex3f(largeur,  hauteur, profondeur);
		glVertex3f(-largeur, hauteur, profondeur);

		glNormal3f(0.0f,-1.0f,1.0f);
		glVertex3f(largeur,  -hauteur, profondeur);
		glVertex3f(-largeur, -hauteur, profondeur);

		glNormal3f(1.0f,0.0f,1.0f);
		glVertex3f(  largeur,  hauteur, profondeur);
		glVertex3f(  largeur, -hauteur, profondeur);

		glNormal3f(-1.0f,0.0f,1.0f);
		glVertex3f(  -largeur,  hauteur, profondeur);
		glVertex3f(  -largeur, -hauteur, profondeur);
		

		// Face arrire
		glNormal3f(0.0f,1.0f,-1.0f);
		glVertex3f(largeur,  hauteur, -profondeur);
		glVertex3f(-largeur, hauteur, -profondeur);

		glNormal3f(0.0f,-1.0f,-1.0f);
		glVertex3f(largeur,  -hauteur, -profondeur);
		glVertex3f(-largeur, -hauteur, -profondeur);

		glNormal3f(1.0f,0.0f,-1.0f);
		glVertex3f(  largeur,  hauteur, -profondeur);
		glVertex3f(  largeur, -hauteur, -profondeur);

		glNormal3f(-1.0f,0.0f,-1.0f);
		glVertex3f(  -largeur,  hauteur, -profondeur);
		glVertex3f(  -largeur, -hauteur, -profondeur);


		// Cot droit
		glNormal3f(1.0f,1.0f,0.0f);
		glVertex3f(largeur,  hauteur, profondeur);
		glVertex3f(largeur, hauteur, -profondeur);

		glNormal3f(1.0f,-1.0f,0.0f);
		glVertex3f(largeur,  -hauteur, profondeur);
		glVertex3f(largeur, -hauteur, -profondeur);

		// Cot gauche
		glNormal3f(-1.0f,1.0f,0.0f);
		glVertex3f(-largeur,  hauteur, profondeur);
		glVertex3f(-largeur, hauteur, -profondeur);

		glNormal3f(-1.0f,-1.0f,0.0f);
		glVertex3f(-largeur,  -hauteur, profondeur);
		glVertex3f(-largeur, -hauteur, -profondeur);

	glEnd();
}

void parallelepipede::Plein (void)
{
	glBindTexture( GL_TEXTURE_2D, 0);
      glBegin(GL_QUADS);
 
		glNormal3f(0.0,0.0,1.0);
		glVertex3f(-largeur,  hauteur, profondeur);
		glVertex3f(-largeur, -hauteur, profondeur);
		glVertex3f( largeur, -hauteur, profondeur);
		glVertex3f( largeur,  hauteur, profondeur);

		glNormal3f(0.0,0.0,-1.0);
		glVertex3f(  largeur,  hauteur, -profondeur);
		glVertex3f(  largeur, -hauteur, -profondeur);
		glVertex3f( -largeur, -hauteur, -profondeur);
		glVertex3f( -largeur,  hauteur, -profondeur);
		

		glNormal3f(1.0,0.0,0.0);
		glVertex3f( largeur,  hauteur,  profondeur);
		glVertex3f( largeur, -hauteur,  profondeur);
		glVertex3f( largeur, -hauteur, -profondeur);
		glVertex3f( largeur,  hauteur, -profondeur);

		glNormal3f(-1.0,0.0,0.0);
		glVertex3f( -largeur,  hauteur,  profondeur);
		glVertex3f( -largeur,  hauteur, -profondeur);
		glVertex3f( -largeur, -hauteur, -profondeur);
		glVertex3f( -largeur, -hauteur,  profondeur);

		glNormal3f(0.0,-1.0,0.0);
		glVertex3f( -largeur, -hauteur,  profondeur);
		glVertex3f( -largeur, -hauteur, -profondeur);
		glVertex3f(  largeur, -hauteur, -profondeur);
		glVertex3f(  largeur, -hauteur,  profondeur);

		glNormal3f(0.0,1.0,0.0);
		glVertex3f( -largeur, hauteur,  profondeur);
		glVertex3f(  largeur, hauteur,  profondeur);
		glVertex3f(  largeur, hauteur, -profondeur);
		glVertex3f( -largeur, hauteur, -profondeur);
	glEnd ();
}
